<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +--------------------------------------------------------+
// | PHP version 5.0.x                                      |
// +--------------------------------------------------------+
// | Copyright (c) 2005 Song Hyo-Jin                        |
// +--------------------------------------------------------+
// | License : GPL (current new version)                    |
// +--------------------------------------------------------+
// | Author : Song Hyo-Jin <crosser at hanmail dot net>     |
// |                                  (MSN Messengerable)   |
// +--------------------------------------------------------+
//
// $Id: CommonSQL.inc, v 0.1.0 2005/08/09 20:20:00 crosser Exp $
//
// Common library for SHJ's SQL class

define('SQL_BIGINT',		'18446744073709551615');
define('SQL_INT',			4294967295);
define('SQL_MEDIUMINT',	16777215);
define('SQL_SMALLINT',	65535);
define('SQL_TINYINT',		255);

// LIKE Query escape
function sql_escape_like($query)
{
	$pattern[]		= '/_/';
	$replacement[]	= '\_';

	$pattern[]		= '/%/';
	$replacement[]	= '\%';

	return preg_replace($pattern, $replacement, $query);
}

// value escape string - must single quot
function sql_escape_string($query)
{
	$pattern[]		= '/\x5c/';
	$replacement[]	= '\\\\';

	$pattern[]		= '/\r\n|\n\r|\r|\n/';
	$replacement[]	= "\n";

	$pattern[]		= '/\'/';
	$replacement[]	= '\'\'';

	return str_replace(CHR00, '\0', preg_replace($pattern, $replacement, $query));
}

function make_table($data, $title = array())
{
	array_walk($data, 'apply_all', 'htmlspecialchars');
	array_walk($data, 'apply_all', 'nl2br');
	$html = '<table border="1" style="border-collapse:collapse;">';
	if(count($title) != 0) {
		array_walk($title, 'apply_all', 'htmlspecialchars');
		$html .= '<tr bgcolor="#e0e0ff">';
		$html .= '<td><b>'.implode('</b></td><td><b>', $title).'</b></td>';
		$html .= '</tr>';
	}
	$flag = 0;
	$switch = array('', '#efefef');
	foreach($data as $value) {
		$html .= '<tr bgcolor="'.$switch[$flag].'">';
		$html .= '<td>'.implode('</td><td>', $value).'</td>';
		$html .= '</tr>';
		$flag = !$flag;
	}
	$html .= '</table>';

	return $html;
}

?>
