<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +--------------------------------------------------------+
// | PHP version 5.0.x                                      |
// +--------------------------------------------------------+
// | Copyright (c) 2005 Song Hyo-Jin                        |
// +--------------------------------------------------------+
// | License : GPL (current new version)                    |
// +--------------------------------------------------------+
// | Author : Song Hyo-Jin <crosser at hanmail dot net>     |
// |                                  (MSN Messengerable)   |
// +--------------------------------------------------------+
//
// $Id: debug.inc, v 0.1.0 2005/08/09 20:20:00 crosser Exp $
//
// for debug and try catch

define('CHR00', chr(0));

if(!isset($_DEBUG)) {
	$_DEBUG = false;
}

function SHJErrorHandler($errno, $errstr, $errfile, $errline)
{
	global $_DEBUG;

	$errname = array(E_ERROR => 'ERROR', E_WARNING => 'WARNING', E_NOTICE => 'NOTICE');

	switch($errno) {
	case E_ERROR:
	case E_WARNING:
		if($errstr == 'Division by zero') {
			break;
		}
	case E_NOTICE:
		throw new Exception($errname[$errno].' : '.$errstr.' : '.$errfile.' : '.$errline.(($_DEBUG) ? "\n".print_r(debug_backtrace(), true) : ''), $errno);
		exit;
	}
}

function SHJExceptionHandler($exception)
{
	echo "\n<xmp>";
	echo $exception->getMessage();
	echo '</xmp>';
	exit;
}

error_reporting(E_ALL);
set_error_handler('SHJErrorHandler');
set_exception_handler('SHJExceptionHandler');

function apply_all(&$arrtext, $callback, $function)
{
	if(is_array($arrtext)) {
		array_walk($arrtext, 'apply_all', $function);
	} else {
		$arrtext = $function($arrtext);
	}

	return true;
}

?>
